package com.franckbarbier.jdbc_javadb;

public final class JDBC_Client {

    private java.sql.Connection _client;
    private org.apache.derby.drda.NetworkServerControl _server = null;

    public JDBC_Client() throws java.sql.SQLException {
        try { // 'derbynet' dependency:
            _server = new org.apache.derby.drda.NetworkServerControl(java.net.InetAddress.getByName("localhost"), 2020);
            _server.start(null);
            System.out.println("Start JDBC server (separate thread)...");
        } catch (Exception e) {
            e.printStackTrace();
        }
        // 'derbyclient' dependency:
        _client = java.sql.DriverManager.getConnection("jdbc:derby://localhost:2020/JDBC_test;create=true");
        java.sql.DatabaseMetaData dmd = _client.getMetaData();
        if (dmd.getSQLStateType() == java.sql.DatabaseMetaData.sqlStateSQL99) {
            System.out.print(dmd.getDatabaseProductName() + " " + dmd.getDatabaseProductVersion() + " is SQL99-compliant\n");
        } else {
            System.out.print(dmd.getDatabaseProductName() + " " + dmd.getDatabaseProductVersion() + " isn't SQL99-compliant\n");
        }
        _client.close();
        try {
            _server.shutdown();
            System.out.println("Stop JDBC server...");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void close() {
        try {
            if (_client != null) {
                _client.close();
            }
        } catch (java.sql.SQLException sqle) {
            throw new RuntimeException(sqle);
        }
    }

    public static void main(String[] args) {
        JDBC_Client test = null;
        try {
            test = new JDBC_Client();
        } catch (java.sql.SQLException sqle) {
            sqle.printStackTrace();
            if (test != null) {
                test.close();
            }
        }
    }
}
